#!/usr/bin/perl
#
# dcnote-smil : 
#   SMIL, REALPIX ե
# Copyright (C) GFD_Dennou_Club, 2001.  All rights reserved.
#
#  Usage : dcreal-smil.pl 
#
#   2001/04/10 ̰ϯ;
#       2002/11/27 
#       2003/09/06 ̰ϯ
#       2004/08/16 ͺ    : ݳعѤ˲
#
#   libjcode-pm-perl ɬ
######################################################################
#Jcode.pm ⥸塼ɤ߹
use Jcode; 

#ʸ
$target_code = "euc"; 

# եɤ߹
$CONF = 'dcreal.conf'; 
while (@ARGV) {
    last unless ($ARGV[0] =~ /^-/);
    $_ = shift;                           
    if (/^-c/) { $CONF = shift; next; }; 
    die "unknown option $_";
}
require "$CONF";


#realpix  bit per seconds
#  2004/08/16 

#ѤȤƻȤ빭׻
# 2004/08/16 
if ($OHPSW) {
    $WIDTH = $WIDTH_SR + $WIDTH_PER; 
    if ($HEIGHT_SR <= $HEIGHT_PER) {
	$HEIGHT = $HEIGHT_PER ;
    }else{
	$HEIGHT = $HEIGHT_SR ;
    }
}else{
    $WIDTH = $WIDTH_PER;
    $HEIGHT = $HEIGHT_PER;
}

#Ǽǥ쥯ȥ
$RMDIR = "../$RMDIR"; 
$SMILDIR = "$RMDIR/smi";
$IMGDIR = "$RMDIR/img-real";

#ӥǥ񸻥ǥ쥯ȥ & 
#饤ɥӥǥֱԥӥǥ 2 ĤѰ : 2004/08/17

unless (-d $RMDIR) {
    mkdir $RMDIR, 0777  ;
    $i = 0; 
    while ($TRT_FILES[$i]) {
	if ($RM_FILES[$i] !~ /^$/){
#	    print "cd $RMDIR; ln -s ../$SRC/$RM_FILES[$i] ./ \n";
	    system("cd $RMDIR; ln -s ../$SRC/$RM_FILES[$i] ./");
	}
	if ($RM_PER[$i] !~ /^$/){
#	    print "cd $RMDIR; ln -s ../$SRC/$RM_PER[$i] ./ \n";
	    system("cd $RMDIR; ln -s ../$SRC/$RM_PER[$i] ./");
	}
	$i++;
    }
}

#SMIL եǼǥ쥯ȥ
mkdir $SMILDIR, 0777  unless -d $SMILDIR ;

#եǼǥ쥯ȥ & 
if ($OHPSW){
    unless (-d $IMGDIR) {
	mkdir $IMGDIR, 0777; 
	system("cd $IMGDIR; ln -s ../../$IMGDIR_RM/* ./");
    }
}

#ߥ󥰥ե뤬¸ߤ뤫ǧ
foreach $TRT (@TRT_FILES) {
    unless (-f $TRT) {
	print "Not $TRT \n"; 
	exit 1;
    }
}

# RealPix ե̾
#  2004/08/16


#ߥ󥰥եΥץ, ɬפʾ. 
$i = 0; 
$e = 0;
while (@TRT_FILES[$e]) {
    open (TIMING, "$TRT_FILES[$e]");
    $start[$e] = $i; 
    while (<TIMING>) {
	chomp(@_);
	#ϻ, OHP ֹ, OHP ȥ̡¸
	$_ =~ /([0-9]+:[0-9]+:[0-9]+),(\d+):(.*)/;
	$time[$i] = $1;
	$ohp_num[$i] = $2;
	($code, $nmatch) = getcode($3);
	print "$code, $nmatch \n"; 
	$ohp_title[$i] = Jcode::convert($3, $target_code, $code); 
	$end[$e] = $i; 
	print "$time[$i], $ohp_num[$i], $ohp_title[$i] \n"; 
	$i++;
    }
    $e++;
    close (TIMING);
}
#print "@start, @end \n" ;


# SMIL եκ
$i = 0;
while ($ohp_num[$i]) {
    #ե̾ν
    $num = sprintf("%03d", $ohp_num[$i]);
    
    #˥ե뤬¸ߤʤΤ SMIL ե
    $SMIL = "$SMILDIR/$num.smi";
    
    $e = 0;
    while ($end[$e]) {
	if ($i >= $start[$e]) {
	    $RM_SR = "$RM_FILES[$e]"; 
	    $RM_PER = "$RM_PER[$e]"; 
	}
	$e ++;
    }
    
    unless (-f $SMIL) {
        print "Making Smil files";
	&print_smi($SMIL, $time[$i], $RM_SR, $RM_PER);
    }  
    $i++;
}

# RealPix եκ
#  2004/08/16 ͺ

exit 0;

#=======================================================================


# SMIL եѥ֥롼
sub print_smi{
    my($smifile, $time, $RM, $PER) = @_;
    open (SMIL, ">$smifile");

    #եؤν񤭽Ф. ꡹ѿ. 
    if ($OHPSW) {
	print SMIL <<EOT
<smil>
<head>
  <meta name="title" content="$TITLE_EN"/>
  <meta name="author" content="$NAME_EN"/>
  <meta name="copyright" content="$COPYRIGHT"/> 
  <layout>
    <root-layout width="$WIDTH" height="$HEIGHT"/>
    <region id="sraid_reg" top="0" left="0" width="$WIDTH_SR" height="$HEIGHT_SR"/>
    <region id="person_reg" top="0" left="$WIDTH_SR" width="$WIDTH_PER" height="$HEIGHT_PER"/>
  </layout>
</head>
<body>
  <par>
     <seq>
       <video src="../$RM" region="sraid_reg" clip-begin="$time"/>
     </seq>
      <video src="../$PER" region="person_reg" clip-begin="$time"/>
  </par>
</body>
</smil>
EOT
;
    }else{
	print SMIL <<EOT
<smil>
<head>
  <meta name="title" content="$TITLE_EN"/>
  <meta name="author" content="$NAME_EN"/>
  <meta name="copyright" content="$COPYRIGHT"/> 
  <layout>
    <root-layout width="$WIDTH" height="$HEIGHT"/>
    <region id="person_reg" top="0" left="0" width="$WIDTH" height="$HEIGHT"/>
  </layout>
</head>
<body>
  <par>
     <seq>
       <video src="../$PER" region="person_reg" clip-begin="$time"/>
     </seq>
  </par>
</body>
</smil>
EOT
;
    }
    close (SMIL);
}


# RealPix ѥ֥롼
#  2004/08/16 ͺ

